{ ------------------------------------------------------------- }
{                                                               }
{   Name:           XBmp_PE.pas                                 }
{   Version:        V 0.2                                       }
{   Author:         Erick I. Jimenez Alvarado                   }
{   To contact:     erickj@usa.net                              }
{                   http://members.xoom.com/erickj              }
{                                                               }
{   Description:    Gradient Property Editor                    }
{                                                               }
{   File Status:    COMPONETWARE ( like a FREEWARE but if you   }
{                   make a Componet or modify this please       }
{                   send or e-mail me this).                    }
{                                                               }
{   Last Upadated:  02/05/99                                    }
{                                                               }
{   History:                                                    }
{                                                               }
{    02/02/99   V0.1 -  First relase version                    }
{    02/05/99   V0.2 -  Add Align property                      }
{                                                               }
{   Finally:        Sorry my bad, bad english and thanks for    }
{                   use my component.                           }
{                                                               }
{ ------------------------------------------------------------- }

{.$DEFINE PRG_UNIT}

{$IFDEF PRG_UNIT}               { ---------------------- }

{$DEFINE PRG_INTERFACE}
{$DEFINE PRG_IMPLEMENTATION}

{$I XTools.Inc } { Directives for all controls }

unit XBmp_PE;

interface

uses

 {$IFNDEF WIN32}
    WinTypes, WinProcs,             { Default Units }
 {$ELSE}
    Windows,                        { Default Unit  }
 {$ENDIF}  { // WIN32 }


  Graphics, Classes, Controls, Forms, Dialogs, ExtDlgs,
  ExtCtrls, StdCtrls, DsgnIntF,

  Spin, //

  GraphExt,                         { My Unit       }
  XObjects,
  XCtrlStd;


{$ENDIF} { // PRG_UNIT }


{$IFDEF PRG_INTERFACE}          { ---------------------- }

{$IFDEF DFS_DELPHI_3_UP}
resourcestring
{$ELSE}
const
{$ENDIF}  { // DFS_DELPHI_3_UP }


    Str_Open_Bmp    = 'Open Bitmap Image';
    Str_Save_Bmp    = 'Save Bitmap Image';
    Str_Bmp_Title   = 'ObjBitmap Editor';
    Str_DrawStyle   = 'Draw Style';
    Str_EfectColor  = 'Efect Color';
    Str_TransMode   = 'Transparent Mode';

    Str_FillInside   = 'Fill Inside';
    Str_IgnorePalette='Ignore Palette';


    Str_DrawStyle_Efects = 'bmNone'         +
                        #13'bmAlign'        +
                        #13'bmStretch'      +
                        #13'bmTile'         +
                        #13'bmSmoothResize';

    Str_TransparentStyle_Efects = 'tsColor'       +
                               #13'tsParentColor' +
                               #13'tsBitmapColor';

    Str_TransparentMode_Efects = 'tmAuto' +
                               #13'tmFixed';

type

{
// --------------------------------------------------------
//  ObjBitmap Property Dialog Class
// --------------------------------------------------------
}
  TObjBitmapEditDlg = class(TForm)
    P1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    BmpPanel: TBackground;
    Background1: TBackground;
    CB_DStyle: TComboBox;
    CB_TStyle: TComboBox;
    CB_TMode: TComboBox;
    EnhBevel1: TEnhBevel;
    EnhBevel2: TEnhBevel;
    Btn_Ok : TButton;
    Btn_Cancel: TButton;
    Btn_BmpLoad: TButton;
    Btn_BmpSave: TButton;
    Btn_BmpClear: TButton;
    About: TButton;
    CD: TColorDialog;
    OpenPD: TOpenPictureDialog;
    SavePD: TSavePictureDialog;
    PEfects: TPanel;
    CB_Transparent: TCheckBox;
    CB_Fill: TCheckBox;
    CB_IPalette: TCheckBox;
    Label5: TLabel;
    CB_Align: TComboBox;
    EnhBevel3: TEnhBevel;
    Btn_Efects: TEnhBevel;
    Label6: TLabel;
    FillBack1: TFillBackground;
    FillBack2: TFillBackground;

    procedure FormCreate(Sender: TObject);
//    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);

    procedure NewColor(Sender: TObject);
    procedure ChangeData(Sender: TObject);
    procedure BmpEvent(Sender: TObject);

  private   { Private declarations }

    FUpdate    : Boolean;

    procedure UpdateCtrls;
//    procedure EnableCtrls;

  end;


{
// --------------------------------------------------------
//  Editor to Property Gradient Class
// --------------------------------------------------------
}
  TObjBitmapProperty = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;


{
// --------------------------------------------------------
//  Util Function
// --------------------------------------------------------
}
function GetNewObjBitmap(Bmp: TObjBitmap): Boolean;

{
// --------------------------------------------------------
//
// --------------------------------------------------------
}


{$ENDIF} { // PRG_INTERFACE }


{$IFDEF PRG_UNIT}               { ---------------------- }


Implementation

Uses
     SysUtils, TypInfo, SysUtlEx;

{$ENDIF} { // PRG_UNIT }


{$IFDEF PRG_IMPLEMENTATION}     { ---------------------- }

{$IFDEF PRG_UNIT}
{$R *.DFM}
{$ELSE}
{$R XBmp_PE.DFM}
{$ENDIF}

{
// --------------------------------------------------------
//  Default Constructor
// --------------------------------------------------------
}
procedure TObjBitmapEditDlg.FormCreate(Sender: TObject);
begin

    Caption := Str_Bmp_Title;
    Label1.Caption := Str_DrawStyle;
    Label2.Caption := Str_EfectColor;
    Label3.Caption := Str_Color;
    Label4.Caption := Str_TransMode;
    Label5.Caption := Str_Align;
    Label6.Caption := Str_Efects;

    Btn_Ok.Caption     := Str_Btn_Ok;
    Btn_Cancel.Caption := Str_Btn_Cancel;

    PEfects.Visible := False;
    PEfects.Left := Btn_Efects.Left;
    PEfects.Top  := Btn_Efects.Top - PEfects.Height;
    Btn_Efects.Tag := 9;
    Btn_Efects.OnClick := ChangeData;


    BmpPanel.Bevel.OuterStyle := efsLowered;

    FillBack1.Background.BackStyle := efbTexture;

    with FillBack2.Background do
    begin
        BackStyle := efbBrush;
        Brush.Style := bsDiagCross;
    end;


    With Btn_BmpLoad do
    Begin
        Tag := 1;
        Caption := Str_Load;
        OnClick := BmpEvent;
    End;

    With Btn_BmpSave do
    Begin
        Tag := 2;
        Caption := Str_Save;
        OnClick := BmpEvent;
        Enabled := False;
    End;

    With Btn_BmpClear do
    Begin
        Tag := 3;
        Caption := Str_Clear;
        OnClick := BmpEvent;
        Enabled := False;
    End;


    OpenPD.Title := Str_Open_Bmp;
    SavePD.Title := Str_Save_Bmp;

    About.OnClick := ChangeData;
    About.Tag := 8;

    { Efects }
    with CB_Transparent do
    begin
        Caption := Str_Transparent;
        OnClick := ChangeData;
        Tag := 5;
    end;

    with CB_Fill do
    begin
        Caption := Str_FillInside;
        OnClick := ChangeData;
        Tag := 6;
    end;

    with CB_IPalette do
    begin
        Caption := Str_IgnorePalette;
        OnClick := ChangeData;
        Tag := 7;
    end;

    { Styles }
    With CB_DStyle do
    Begin
        Items.Text:= Str_DrawStyle_Efects;          { Put names of all efects }
        OnChange  := ChangeData;
        Tag := 1;
    End;

    With CB_Align do
    Begin
        Items.Text:= Str_Align_Efects;              { Put names of all efects }
        OnChange  := ChangeData;
        Tag := 2;
    End;

    With CB_TMode do
    Begin
        Items.Text:= Str_TransparentMode_Efects;    { Put names of all efects }
        OnChange  := ChangeData;
        Tag := 3;
    End;

    With CB_TStyle do
    Begin
        Items.Text:= Str_TransparentStyle_Efects;   { Put names of all efects }
        OnChange  := ChangeData;
        Tag := 4;
    End;


    P1.OnClick := NewColor;

    FUpdate := False;
end;

{
// --------------------------------------------------------
//  Default Destructor
// --------------------------------------------------------
}
//procedure TObjBitmapEditDlg.FormDestroy(Sender: TObject);
//begin
    //
//end;

{
// --------------------------------------------------------
//  Activate Handle
// --------------------------------------------------------
}
procedure TObjBitmapEditDlg.FormActivate(Sender: TObject);
begin
    if (not FUpdate) then
        FUpdate := True;
end;


{
// --------------------------------------------------------
//  Reset all vars
// --------------------------------------------------------
}
procedure TObjBitmapEditDlg.UpdateCtrls;
Begin

    with FillBack1.Background.Texture do
    Begin

        CB_Transparent.Checked  := Transparent;
        CB_Fill.Checked         := FillInside;
        CB_IPalette.Checked     := IgnorePalette;

        CB_Align.ItemIndex   := Integer(Align);
        CB_DStyle.ItemIndex  := Integer(DrawStyle);
        CB_TStyle.ItemIndex  := Integer(TransparentStyle);
        CB_TMode.ItemIndex   := Integer(TransparentMode);

        P1.Color := Color;

        Btn_BmpSave.Enabled := not Bitmap.Empty;
        Btn_BmpClear.Enabled := not Bitmap.Empty;

    end;
End;

{
// --------------------------------------------------------
//  Set Swap Option
// --------------------------------------------------------
}
procedure TObjBitmapEditDlg.ChangeData(Sender: TObject);
Begin

    if not (FUpdate) then
        exit;

    with FillBack1.Background.Texture do
    Begin
        case (Sender as TComponent).Tag of
            1 : DrawStyle       := TBitmapDrawStyle(CB_DStyle.ItemIndex);
            2 : Align           := TEnhAlign(CB_Align.ItemIndex);
            3 : TransparentMode := TTransparentMode(CB_TMode.ItemIndex);
            4 : TransparentStyle:= TTransparentStyle(CB_TStyle.ItemIndex);
            5 : Transparent     := CB_Transparent.Checked;
            6 : FillInside      := CB_Fill.Checked;
            7 : IgnorePalette   := CB_IPalette.Checked;
            8 : MessageDlg(Str_About_XTools,mtInformation,[mbOK],0);
            9 : Begin
                    if (Btn_Efects.Bevel.OuterStyle = efsRaised) then
                    Begin
                        Btn_Efects.Bevel.OuterStyle := efsLowered;
                        PEfects.Visible := True;
                    end
                    else
                    Begin
                        Btn_Efects.Bevel.OuterStyle := efsRaised;
                        PEfects.Visible := False;
                    end;
                End;
        end;
    end;

    UpdateCtrls;

End;


{
// --------------------------------------------------------
//  Default Handle Change Color
// --------------------------------------------------------
}
procedure TObjBitmapEditDlg.NewColor(Sender: TObject);
Begin

    if not (FUpdate) then
        exit;

    CD.Color  := FillBack1.Background.Texture.Color;

    { Execute Color Dialog  }
    if CD.Execute then
    Begin

        FillBack1.Background.Texture.Color := CD.Color;

//        if (FUpdate) then
            UpdateCtrls;

    end;
end;

{
// --------------------------------------------------------
//  Default Read Bitmap
// --------------------------------------------------------
}
procedure TObjBitmapEditDlg.BmpEvent(Sender: TObject);
Var
    Idx : Integer;

begin
    if not (FUpdate) then
        exit;

    Idx := (Sender as TComponent).Tag;

    With FillBack1.Background.Texture.Bitmap do
    if (Idx = 1) then
    begin
        OpenPD.FileName := '';
        if (OpenPD.Execute) then
        begin
            Application.ProcessMessages;
            LoadFromFile(OpenPD.FileName);
        end;
    end
    else if (Idx = 2) then
    begin
        SavePD.FileName := '';
        if (SavePD.Execute) then
            SaveToFile(SavePD.FileName);
    end
    else if (Idx = 3) then
        Assign(nil)
    else
        Exit;

    UpdateCtrls;
end;


{
// --------------------------------------------------------
//  Editor to Property TObjBitmap Class
// --------------------------------------------------------
}
procedure TObjBitmapProperty.Edit;
Var
  tmpBmp : TObjBitmap;

Begin

    TmpBmp := TObjBitmap.Create;

  try

    TmpBmp.Assign(TObjBitmap(Pointer(GetOrdValue)));

    { Execute Dialog Property Editor }
    if GetNewObjBitmap(tmpBmp) then
        SetOrdValue(Longint(Pointer(TmpBmp)));   { Assign New Values }

  finally

    TmpBmp.Free;

  end;


end;

{
// --------------------------------------------------------
//  Atributtes of Property Editor
// --------------------------------------------------------
}
function TObjBitmapProperty.GetAttributes: TPropertyAttributes;
Begin
    Result := [paDialog, paSubProperties, paMultiSelect];
End;


{
// --------------------------------------------------------
//  Execute Dialog Property Editor and copy data
// --------------------------------------------------------
}
function GetNewObjBitmap(Bmp: TObjBitmap): Boolean;
Begin

    Result  := False;

    with TObjBitmapEditDlg.Create(Application) do
    Begin

      try

        FillBack1.Background.Texture.Assign(Bmp);         { Copy all Settings     }

        UpdateCtrls;

        if (Showmodal = mrOK) then
        begin

          Bmp.Assign(FillBack1.Background.Texture);        { Copy New Settings     }
          Result := True;

        end;

      finally

        Free;

      end;

    end;
end;
{$ENDIF} { // PRG_IMPLEMENTATION }

{$IFDEF PRG_UNIT}               { ---------------------- }
end.
{$ENDIF} { // PRG_UNIT }
